
public class p4simple {
  public static void main(String[] args) {
    P4.initEnv(args);
    P4.createProcGroup() ;

    worker() ; 

    P4.waitForEnd() ;
  }

  static void worker() {
    int myId   = P4.getMyId() ;
    int nprocs = P4.numTotalIds() ;

    int [] msg = {23} ;
    SendBuffer outgoing = new SendBuffer(msg) ;

    for(int i = 0 ; i < nprocs ; i++) {
      if(i != myId)
        P4.send(100, i, outgoing) ;
    }

    int [] dat = new int [1] ;
    RecvBuffer incoming = new RecvBuffer(dat) ;

    for(int i = 0 ; i < nprocs - 1 ; i++) {
      P4.recv(-1, -1, incoming) ;

      System.out.println("" + myId + " received = msg =:" +
                         dat [0] + ": from " + incoming.from()) ;
    }
  }
}


